#!/bin/sh
#
# USERNAME
# PASSWORD
# SAMBAPREFIX
# DOMAINNAME
# BROADCAST

# Broadcast to find a domain controller
echo "Domain name: $DOMAINNAME"
echo "Broadcast IP address: $BROADCAST"
dcip=`$SAMBAPREFIX/bin/nmblookup -B $BROADCAST $DOMAINNAME#1b | awk '/[0-9.]+ / { print $1 ; exit }'`
[ -n "$dcip" ] || exit 1
echo "Domain controller IP address: $dcip"

# All right, we have the IP address of a domain controller,
# but we need its name too
dcname=`$SAMBAPREFIX/bin/nmblookup -A $dcip | awk '$2 == "<00>" { print $1 ; exit }'`
[ -n "$dcname" ] || exit 1
echo "Domain controller NETBIOS name: $dcname"

# Pass password to smbclient through environment. Not really safe.
USER="$USERNAME%$PASSWORD"
export USER

# Read the contents of the file "proxyauth" on the NETLOGON share
proxyauth=`$SAMBAPREFIX/bin/smbclient //$dcname/NETLOGON -I $dcip -E -W "$DOMAINNAME" -c "get proxyauth -" 2>/dev/null`
echo "Contents of //$dcname/NETLOGON/proxyauth: $proxyauth"
[ "$proxyauth" = "allow" ] || exit 1
exit 0


